#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    cin>>t;
    for(int iter=0; iter<t; iter++)
    {
        int n, m;
        cin>>n>>m;
        int a[n];
        int b[m];
        for(int i=0; i<n; i++)
            cin>>a[i];
        for(int i=0; i<m; i++)
            cin>>b[i];
        for(int i=0; i<n; i++)
        {
            a[i]-=a[0];
        }
        int d=a[1];
        for(int i=2; i<n; i++)
        {
            d=__gcd(d, a[i]);
        }
        for(int i=0; i<m; i++)
            if((b[i]-a[0])%d == 0)
        {
            cout<<0;
            break;
        }
        cout<<1;
    }
}